VERSION 5.00
Begin VB.Form frmGen834Ex41 
   Caption         =   "Generate EDI X12 834 Scenario 1"
   ClientHeight    =   2445
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5115
   LinkTopic       =   "Form1"
   ScaleHeight     =   2445
   ScaleWidth      =   5115
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   495
      Left            =   3000
      TabIndex        =   1
      Top             =   1440
      Width           =   1215
   End
   Begin VB.CommandButton cmdGenerate 
      Caption         =   "Generate"
      Height          =   495
      Left            =   840
      TabIndex        =   0
      Top             =   1440
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Business Scenario 1 - Enroll an Employee in Multiple Health Care Insurance Products"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   240
      TabIndex        =   2
      Top             =   240
      Width           =   4455
   End
End
Attribute VB_Name = "frmGen834Ex41"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'SAMPLE PROGRAM FOR X095.PDF SECTION 4.1 PROFESSIONAL, EXAMPLE 4.1.1.
'THIS PROGRAM USES THE EDIDEV FRAMEWORK EDI COM.
'AUTHOR: EDIDEV
Option Explicit
Private oEdiDoc As Fredi.ediDocument
Private oSchema As Fredi.ediSchema
Private oSchemas As Fredi.ediSchemas
Private oInterchange As Fredi.ediInterchange
Private oGroup As Fredi.ediGroup
Private oTransactionset As Fredi.ediTransactionSet
Private oSegment As Fredi.ediDataSegment
Private sSefFile As String
Private sEdiFile As String

Public Sub cmdClose_Click()

    Set oSegment = Nothing
    Set oTransactionset = Nothing
    Set oGroup = Nothing
    Set oInterchange = Nothing
    Set oSchema = Nothing
    Set oEdiDoc = Nothing
    Unload Me
    
End Sub

Public Sub cmdGenerate_Click()
    Dim i As Integer
    Dim nCount As Integer
    Dim sPath As String
    Dim sEntity As String
    Dim nIndex As Integer
    Dim sSefFile As String
    Dim sEdiFile As String
    Dim iItemCount As Integer
    Dim sInstance As String
    Dim iTs As Integer
    
    Me.MousePointer = vbHourglass
    sPath = App.Path & "\"
    
    sSefFile = sPath & "834_X095.sef"
    
    Set oEdiDoc = New Fredi.ediDocument
    
    'THIS MAKES CERTAIN THAT FREDI ONLY USES THE SEF FILE PROVIDED, AND THAT IT DOES
    'NOT USE ITS BUILT-IN STANDARD REFERENCE TABLE TO TRANSLATE THE EDI FILE.
    Set oSchemas = oEdiDoc.GetSchemas
    oSchemas.EnableStandardReference = False
     
    
    Set oSchema = oEdiDoc.LoadSchema(sSefFile, 0)
    
    For iTs = 1 To 50
        sEdiFile = sPath & "files\" & "X095Output" & Trim(Str(iTs)) & ".X12"
    
        oEdiDoc.New
        
        'THIS OPTIONS STOPS FREDI FROM KEEPING ALL THE SEGMENTS IN MEMORY
        oEdiDoc.CursorType = Cursor_ForwardWrite
        
        oEdiDoc.SegmentTerminator = "~" & vbCrLf
        oEdiDoc.ElementTerminator = "*"
        oEdiDoc.CompositeTerminator = ":"
        
        Set oInterchange = oEdiDoc.CreateInterchange("X", "004010")
        Set oGroup = oInterchange.CreateGroup("004010X095")
        Set oTransactionset = oGroup.CreateTransactionSet("834")
        
        
        Set oSegment = oInterchange.GetDataSegmentHeader
        oSegment.DataElementValue(1) = "00"
        oSegment.DataElementValue(3) = "00"
        oSegment.DataElementValue(5) = "12"
        oSegment.DataElementValue(6) = "Sender"
        oSegment.DataElementValue(7) = "12"
        oSegment.DataElementValue(8) = "ReceiverID"
        oSegment.DataElementValue(9) = "010821"
        oSegment.DataElementValue(10) = "1548"
        oSegment.DataElementValue(11) = "U"
        oSegment.DataElementValue(12) = "00401"
        oSegment.DataElementValue(13) = "000000020"
        oSegment.DataElementValue(14) = "0"
        oSegment.DataElementValue(15) = "T"
        oSegment.DataElementValue(16) = ":"
        
        Set oSegment = oGroup.GetDataSegmentHeader
        oSegment.DataElementValue(1) = "BE"
        oSegment.DataElementValue(2) = "SenderDept"
        oSegment.DataElementValue(3) = "ReceiverDept"
        oSegment.DataElementValue(4) = "20010821"
        oSegment.DataElementValue(5) = "1548"
        oSegment.DataElementValue(6) = "000001"
        oSegment.DataElementValue(7) = "X"
        oSegment.DataElementValue(8) = "004010X095"
        
        'HEADER
        'ST TRANSACTION SET HEADER
        Set oSegment = oTransactionset.GetDataSegmentHeader
        oSegment.DataElementValue("329") = "12345"
        
        'Beginning Segment
        Set oSegment = oTransactionset.CreateDataSegment("BGN")
        oSegment.DataElementValue(1) = "00"
        oSegment.DataElementValue(2) = "12456"
        oSegment.DataElementValue(3) = "19980520"
        oSegment.DataElementValue(4) = "1200"
        oSegment.DataElementValue(8) = "2"
    
        'Plan Sponsor
        Set oSegment = oTransactionset.CreateDataSegment("N1\N1")
        oSegment.DataElementValue(1) = "P5"
        oSegment.DataElementValue(3) = "FI"
        oSegment.DataElementValue(4) = "999888777"
        
        'Payer
        Set oSegment = oTransactionset.CreateDataSegment("N1(2)\N1")
        oSegment.DataElementValue(1) = "IN"
        oSegment.DataElementValue(3) = "FI"
        oSegment.DataElementValue(4) = "654456654"
        
        'Member Level Detail
        Set oSegment = oTransactionset.CreateDataSegment("INS\INS")
        oSegment.DataElementValue(1) = "Y"
        oSegment.DataElementValue(2) = "18"
        oSegment.DataElementValue(3) = "021"
        oSegment.DataElementValue(4) = "20"
        oSegment.DataElementValue(5) = "A"
        oSegment.DataElementValue(8) = "FT"
        
        'Subscriber Number
        Set oSegment = oTransactionset.CreateDataSegment("INS\REF")
        oSegment.DataElementValue(1) = "0F"
        oSegment.DataElementValue(2) = "123456789"
        
        'Member Policy Number
        Set oSegment = oTransactionset.CreateDataSegment("INS\REF(2)")
        oSegment.DataElementValue(1) = "1L"
        oSegment.DataElementValue(2) = "123456001"
        
        'Member Level Dates
        Set oSegment = oTransactionset.CreateDataSegment("INS\DTP")
        oSegment.DataElementValue(1) = "356"
        oSegment.DataElementValue(2) = "D8"
        oSegment.DataElementValue(3) = "19960523"
        
        'Member Name
        Set oSegment = oTransactionset.CreateDataSegment("INS\NM1\NM1")
        oSegment.DataElementValue(1) = "IL"
        oSegment.DataElementValue(2) = "1"
        oSegment.DataElementValue(3) = "DOE"
        oSegment.DataElementValue(4) = "JOHN"
        oSegment.DataElementValue(5) = "P"
        oSegment.DataElementValue(8) = "34"
        oSegment.DataElementValue(9) = "123456789"
        
        'Member Communications Numbers
        Set oSegment = oTransactionset.CreateDataSegment("INS\NM1\PER")
        oSegment.DataElementValue(1) = "IP"
        oSegment.DataElementValue(3) = "HP"
        oSegment.DataElementValue(4) = "7172343334"
        oSegment.DataElementValue(5) = "WP"
        oSegment.DataElementValue(6) = "7172341240"
    
        'Member Residence Street Address
        Set oSegment = oTransactionset.CreateDataSegment("INS\NM1\N3")
        oSegment.DataElementValue(1) = "100 MARKET ST."
        oSegment.DataElementValue(2) = "APT 3G"
        
        'Member Residence City, State, ZIP Code
        Set oSegment = oTransactionset.CreateDataSegment("INS\NM1\N4")
        oSegment.DataElementValue(1) = "CAMP HILL"
        oSegment.DataElementValue(2) = "PA"
        oSegment.DataElementValue(3) = "17011"
        oSegment.DataElementValue(5) = "CY"
        oSegment.DataElementValue(6) = "CUMBERLAND"
    
        'Member Demographics
        Set oSegment = oTransactionset.CreateDataSegment("INS\NM1\DMG")
        oSegment.DataElementValue(1) = "D8"
        oSegment.DataElementValue(2) = "19400816"
        oSegment.DataElementValue(3) = "M"
    
        'Health Coverage - Health
        Set oSegment = oTransactionset.CreateDataSegment("INS\HD\HD")
        oSegment.DataElementValue(1) = "021"
        oSegment.DataElementValue(3) = "HLT"
    
        'Health Coverage Dates
        Set oSegment = oTransactionset.CreateDataSegment("INS\HD\DTP")
        oSegment.DataElementValue(1) = "348"
        oSegment.DataElementValue(2) = "D8"
        oSegment.DataElementValue(3) = "19960601"
    
        'Coordination of Benefits
        Set oSegment = oTransactionset.CreateDataSegment("INS\HD\COB\COB")
        oSegment.DataElementValue(1) = "P"
        oSegment.DataElementValue(2) = "890111"
        oSegment.DataElementValue(3) = "5"
    
        'Other Insurance Company Name
        Set oSegment = oTransactionset.CreateDataSegment("INS\HD\COB\N1")
        oSegment.DataElementValue(1) = "IN"
        oSegment.DataElementValue(2) = "ABC INSURANCE CO"
        
        'Health Coverage - Dental
        Set oSegment = oTransactionset.CreateDataSegment("INS\HD(2)\HD")
        oSegment.DataElementValue(1) = "021"
        oSegment.DataElementValue(3) = "DEN"
    
        Set oSegment = oTransactionset.CreateDataSegment("INS\HD(2)\DTP")
        oSegment.DataElementValue(1) = "348"
        oSegment.DataElementValue(2) = "D8"
        oSegment.DataElementValue(3) = "19960601"
    
        'Health Coverage - Vision
        Set oSegment = oTransactionset.CreateDataSegment("INS\HD(3)\HD")
        oSegment.DataElementValue(1) = "021"
        oSegment.DataElementValue(3) = "VIS"
    
        Set oSegment = oTransactionset.CreateDataSegment("INS\HD(3)\DTP")
        oSegment.DataElementValue(1) = "348"
        oSegment.DataElementValue(2) = "D8"
        oSegment.DataElementValue(3) = "19960601"
    
        oEdiDoc.Save sEdiFile
    Next
    
    Me.MousePointer = vbNormal
    cmdGenerate.Enabled = False
    
End Sub

